Apache Core Features

### Apache HTTP Server Version 1.2

# Apache Core Features

These configuration parameters control the core Apache features, and are always available.

- AccessConfig
- AccessFileName
- AddModule
- AllowOverride
- AuthName
- AuthType
- BindAddress
- ClearModuleList
- DefaultType
- <Directory>
- DocumentRoot
- ErrorDocument
- ErrorLog
- <Files>
- Group
- HostNameLookups
- IdentityCheck
- <IfModule>
- KeepAlive
- KeepAliveTimeout
- <Limit>
- Listen
- <Location>
- LockFile
- MaxClients
- MaxKeepAliveRequests
- MaxRequestsPerChild
- MaxSpareServers
- MinSpareServers
- Options
- PidFile
- Port
- require
- ResourceConfig
- RLimitCPU
- RLimitMEM
- RLimitNPROC
- Satisfy
- ScoreBoardFile
- SendBufferSize
- ServerAdmin
- ServerAlias
- ServerName
- ServerPath
- ServerRoot
- ServerType
- StartServers
- TimeOut
- User
- <VirtualHost>

## AccessConfig directive

Syntax: AccessConfig filename
Default: `AccessConfig conf/access.conf`
Context: server config, virtual host
Status: core

The server will read this file for more directives after reading the ResourceConfig file. Filename is relative to the ServerRoot. This feature can be disabled using:

> `AccessConfig /dev/null`

Historically, this file only contained <Directory> sections; in fact it can now contain any server directive allowed in the server config context.

## AccessFileName directive

Syntax: AccessFileName filename
Default: `AccessFileName .htaccess`
Context: server config, virtual host
Status: core

When returning a document to the client the server looks for an access control file with this name in every directory of the path to the document, if access control files are enabled for that directory. For example:

> `AccessFileName .acl`

before returning the document /usr/local/web/index.html, the server will read /.acl, /usr/.acl, /usr/local/.acl and /usr/local/web/.acl for directives, unless they have been disabled with

> `<Directory />
> AllowOverride None
> </Directory>`

## AddModule directive

Syntax: AddModule module module ...
Context: server config
Status: core
Compatibility: AddModule is only available in Apache 1.2 and later

The server can have modules compiled in which are not actively in use. This directive can be used to enable the use of those modules. The server comes with a pre-loaded list of active modules; this list can be cleared with the ClearModuleList directive.

## AllowOverride directive

Syntax: AllowOverride override override ...
Default: `AllowOverride All`
Context: directory
Status: core

When the server finds an .htaccess file (as specified by AccessFileName) it needs to know which directives declared in that file can override earlier access information.

Override can be set to `None`, in which case the server will not read the file, `All` in which case the server will allow all the directives, or one or more of the following:

AuthConfig
  Allow use of the authorization directives (AuthDBMGroupFile, AuthDBMUserFile, AuthGroupFile, AuthName, AuthType, AuthUserFile, require, etc.).
FileInfo
  Allow use of the directives controlling document types (AddEncoding, AddLanguage, AddType, DefaultType, ErrorDocument, LanguagePriority, etc.).
Indexes
  Allow use of the directives controlling directory indexing (AddDescription, AddIcon, AddIconByEncoding, AddIconByType, DefaultIcon, DirectoryIndex, FancyIndexing, HeaderName, IndexIgnore, IndexOptions, ReadmeName, etc.).
Limit
  Allow use of the directives controlling host access (allow, deny and order).
Options
  Allow use of the directives controlling specific directory features (Options and XBitHack).

## AuthName directive

Syntax: AuthName auth-domain
Context: directory, .htaccess
Override: AuthConfig
Status: core

This directive sets the name of the authorization realm for a directory. This realm is given to the client so that the user knows which username and password to send. It must be accompanied by AuthType and require directives, and directives such as AuthUserFile and AuthGroupFile to work.

## AuthType directive

Syntax: AuthType type
Context: directory, .htaccess
Override: AuthConfig
Status: core

This directive selects the type of user authentication for a directory. Only `Basic` is currently implemented. It must be accompanied by AuthName and require directives, and directives such as AuthUserFile and AuthGroupFile to work.

## BindAddress directive

Syntax: BindAddress saddr
Default: `BindAddress *`
Context: server config
Status: core

A Unix® http server can either listen for connections to every IP address of the server machine, or just one IP address of the server machine. Saddr can be

- *
- An IP address
- A fully-qualified Internet domain name If the value is *, then the server will listen for connections on every IP address, otherwise it will only listen on the IP address specified.

  This option can be used as an alternative method for supporting virtual hosts instead of using <VirtualHost> sections.

  See Also: DNS Issues
  See Also: Setting which addresses and ports Apache uses

  ## ClearModuleList directive

  Syntax: ClearModuleList
  Context: server config
  Status: core
  Compatibility: ClearModuleList is only available in Apache 1.2 and later

  The server comes with a built-in list of active modules. This directive clears the list. It is assumed that the list will then be re-populated using the AddModule directive.

  ## DefaultType directive

  Syntax: DefaultType mime-type
  Default: `DefaultType text/html`
  Context: server config, virtual host, directory, .htaccess
  Override: FileInfo
  Status: core

  There will be times when the server is asked to provide a document whose type cannot be determined by its MIME types mappings.

  The server must inform the client of the content-type of the document, so in the event of an unknown type it uses the `DefaultType`. For example:

  > `DefaultType image/gif`

  would be appropriate for a directory which contained many gif images with filenames missing the .gif extension.

  ## <Directory> directive

  Syntax: <Directory directory> ... </Directory>
  Context: server config, virtual host
  Status: Core.

  <Directory> and </Directory> are used to enclose a group of directives which will apply only to the named directory and sub-directories of that directory. Any directive which is allowed in a directory context may be used. Directory is either the full path to a directory, or a wild-card string. In a wild-card string, `?' matches any single character, and `*' matches any sequences of characters. Example:

         <Directory /usr/local/httpd/htdocs>
         Options Indexes FollowSymLinks
         </Directory>

  Apache 1.2 and above: Extended regular expressions can also be used, with the addition of the `~` character. For example:

         <Directory ~ "^/www/.*/[0-9]{3}">

  would match directories in /www/ that consisted of three numbers.

  If multiple directory sections match the directory (or its parents) containing a document, then the directives are applied in the order of shortest match first, interspersed with the directives from the .htaccess files. For example, with

  > `<Directory />
  > AllowOverride None
  > </Directory>
  > <Directory /home/*>
  > AllowOverride FileInfo
  > </Directory>`

  for access to the document `/home/web/dir/doc.html` the steps are:
- Apply directive `AllowOverride None` (disabling `.htaccess` files).
- Apply directive `AllowOverride FileInfo` (for directory `/home/web`).
- Apply any FileInfo directives in `/home/web/.htaccess`

  Note that the default Apache access for <Directory /> is `Allow from All`. This means that Apache will serve any file mapped from an URL. It is recommended that you change this with a block such as

       <Directory />
           Order Deny,Allow
           Deny from All
       </Directory>

  and then override this for directories you want accessible. See the Security Tips page for more details.

  The directory sections typically occur in the access.conf file, but they may appear in any configuration file. <Directory> directives cannot nest, and cannot appear in a <Limit> section.

  ## DocumentRoot directive

  Syntax: DocumentRoot directory-filename
  Default: `DocumentRoot /usr/local/etc/httpd/htdocs`
  Context: server config, virtual host
  Status: core

  This directive sets the directory from which httpd will serve files. Unless matched by a directive like Alias, the server appends the path from the requested URL to the document root to make the path to the document. Example:

  > `DocumentRoot /usr/web`

  then an access to `http://www.my.host.com/index.html` refers to `/usr/web/index.html`.

  There appears to be a bug in mod_dir which causes problems when the DocumentRoot has a trailing slash (i.e. "DocumentRoot /usr/web/") so please avoid that.

  ## ErrorDocument directive

  Syntax: ErrorDocument error-code document
  Context server config, virtual host, directory, .htaccess
  Status: core
  Override: FileInfo
  Compatibility: The directory and .htaccess contexts are only available in Apache 1.1 and later.

  In the event of a problem or error, Apache can be configured to do one of four things,

  1. output a simple hardcoded error message
  2. output a customized message
  3. redirect to a local URL to handle the problem/error
  4. redirect to an external URL to handle the problem/error

  The first option is the default, while options 2-4 are configured using the `ErrorDocument` directive, which is followed by the HTTP response code and a message or URL.

  Messages in this context begin with a single quote (`"`), which does not form part of the message itself. Apache will sometimes offer additional information regarding the problem/error.

  URLs can begin with a slash (/) for local URLs, or be a full URL which the client can resolve. Examples:

  > `ErrorDocument 500 http://foo.example.com/cgi-bin/tester
  > ErrorDocument 404 /cgi-bin/bad_urls.pl
  > ErrorDocument 401 /subscription_info.html
  > ErrorDocument 403 "Sorry can't allow you access today`

  Note that when you specify an `ErrorDocument` that points to a remote URL (ie. anything with a method such as "http" in front of it) Apache will send a redirect to the client to tell it where to find the document, even if the document ends up being on the same server.. This has several implications, the most important being that if you use an "ErrorDocument 401" directive then it must refer to a local document. This results from the nature of the HTTP basic authentication scheme.

  See Also: documentation of customizable responses.

  ## ErrorLog directive

  Syntax: ErrorLog filename
  Default: `ErrorLog logs/error_log`
  Context: server config, virtual host
  Status: core

  The error log directive sets the name of the file to which the server will log any errors it encounters. If the filename does not begin with a slash (/) then it is assumed to be relative to the ServerRoot. Example:

  > `ErrorLog /dev/null`

  This effectively turns off error logging.

  SECURITY: See the security tips document for details on why your security could be compromised if the directory where logfiles are stored is writable by anyone other than the user that starts the server.

  ## <Files>

  Syntax: <Files filename> ... </Files>
  Context: server config, virtual host, htaccess
  Status: core
  Compatibility: only available in Apache 1.2 and above.

  The <Files> directive provides for access control by filename. It is comparable to the <Directory> directive and <Location> directives. It should be matched with a </Files> directive. Directives that apply to the filename given should be listed within. `<Files>` sections are processed in the order they appear in the configuration file, after the <Directory> sections and `.htaccess` files are read, but before <Location> sections.

  The filename argument should include a filename, or a wild-card string, where `?' matches any single character, and `*' matches any sequences of characters. Extended regular expressions can also be used, with the addition of the `~` character. For example:

         <Files ~ "\.(gif|jpe?g|png)$">

  would match most common Internet graphics formats.

  Note that unlike `<Directory>` and `<Location>` sections, `<Files>` sections can be used inside .htaccess files. This allows users to control access to their own files, at a file-by-file level. When used in an .htaccess file, if the filename does not begin with a `/` character, the directory being applied will be prefixed automatically.

  ## Group directive

  Syntax: Group unix-group
  Default: `Group #-1`
  Context: server config, virtual host
  Status: core

  The Group directive sets the group under which the server will answer requests. In order to use this directive, the stand-alone server must be run initially as root. Unix-group is one of:

  A group name
    Refers to the given group by name.
  # followed by a group number.
    Refers to a group by its number.
  It is recommended that you set up a new group specifically for running the server. Some admins use user `nobody`, but this is not always possible or desirable.

  Note: if you start the server as a non-root user, it will fail to change to the specified group, and will instead continue to run as the group of the original user.

  Special note: Use of this directive in <VirtualHost> requires a properly configured suEXEC wrapper. When used inside a <VirtualHost> in this manner, only the group that CGIs are run as is affected. Non-CGI requests are still processed as the group specified in the main Group directive.

  SECURITY: See User for a discussion of the security considerations.

  ## HostNameLookups directive

  Syntax: HostNameLookups boolean
  Default: `HostNameLookups on`
  Context: server config, virtual host
  Status: core

  This directive enables DNS lookups so that host names can be logged. Having this directive set `on` also enables the use of names in <Limit> blocks for access control.

  Heavily loaded sites should set this directive `off`, since DNS lookups can take considerable amounts of time. The utility logresolve, provided in the /support directory, can be used to look up host names from logged IP addresses offline.

  ## IdentityCheck directive

  Syntax: IdentityCheck boolean
  Default: `IdentityCheck off`
  Context: server config, virtual host
  Status: core

  This directive enables RFC1413-compliant logging of the remote user name for each connection, where the client machine runs identd or something similar. This information is logged in the access log. Boolean is either `on` or `off`.

  The information should not be trusted in any way except for rudimentary usage tracking.

  Note that this can cause serious latency problems accessing your server since every request requires one of these lookups to be performed. When firewalls are involved each lookup might possibly fail and add 30 seconds of latency to each hit. So in general this is not very useful on public servers accessible from the Internet.

  ## <IfModule>

  Syntax: <IfModule [!]module-name> ... </IfModule>
  Default: None
  Context: all
  Status: Core Compatibility: ScriptLog is only available in 1.2 and later.

  The <IfModule test>...</IfModule> section is used to mark directives that are conditional. The directives within an IfModule section are only processed if the test is true. If test is false, everything between the start and end markers is ignored.

  The test in the <IfModule> section directive can be one of two forms:

  - module name
  - !module name

  In the former case, the directives between the start and end markers are only processed if the module named module name is compiled in to Apache. The second format reverses the test, and only processes the directives if module name is not compiled in.

  The module name argument is a module name as given as the file name of the module, at the time it was compiled. For example, `mod_rewrite.c`.

  <IfModule> sections are nest-able, which can be used to implement simple multiple-module tests.

  ## KeepAlive

  Syntax: (Apache 1.1) KeepAlive max-requests
  Default: (Apache 1.1) `KeepAlive 5`
  Syntax: (Apache 1.2) KeepAlive on/off
  Default: (Apache 1.2) `KeepAlive On`
  Context: server config
  Status: Core
  Compatibility: KeepAlive is only available in Apache 1.1 and later.

  This directive enables Keep-Alive support.

  Apache 1.1: Set max-requests to the maximum number of requests you want Apache to entertain per request. A limit is imposed to prevent a client from hogging your server resources. Set this to `0` to disable support.

  Apache 1.2 and later: Set to "On" to enable persistent connections, "Off" to disable. See also the MaxKeepAliveRequests directive.

  ## KeepAliveTimeout

  Syntax: KeepAliveTimeout seconds
  Default: `KeepAliveTimeout 15`
  Context: server config
  Status: Core
  Compatibility: KeepAliveTimeout is only available in Apache 1.1 and later.

  The number of seconds Apache will wait for a subsequent request before closing the connection. Once a request has been received, the timeout value specified by the `Timeout` directive applies.

  ## Listen

  Syntax: Listen [IP address:]port number
  Context: server config
  Status: core
  Compatibility: Listen is only available in Apache 1.1 and later.

  The Listen directive instructs Apache to listen to more than one IP address or port; by default it responds to requests on all IP interfaces, but only on the port given by the Port directive.

  See Also: DNS Issues
  See Also: Setting which addresses and ports Apache uses
  See Also: Known Bugs

  ## <Limit> directive

  Syntax: <Limit method method ... > ... </Limit>
  Context: any
  Status: core

  <Limit> and </Limit> are used to enclose a group of access control directives which will then apply only to the specified access methods, where method is any valid HTTP method. Any directive except another <Limit> or <Directory> may be used; the majority will be unaffected by the <Limit>. Example:

  > `<Limit GET POST>
  > require valid-user
  > </Limit>`

  If an access control directive appears outside a <Limit> directive, then it applies to all access methods.

  ## <Location>

  Syntax: <Location URL> ... </Location>
  Context: server config, virtual host
  Status: core
  Compatibility: Location is only available in Apache 1.1 and later.

  The <Location> directive provides for access control by URL. It is comparable to the <Directory> directive, and should be matched with a </Location> directive. Directives that apply to the URL given should be listed within. `<Location>` sections are processed in the order they appear in the configuration file, after the <Directory> sections and `.htaccess` files are read.

  Note that, due to the way HTTP functions, URL prefix should, save for proxy requests, be of the form `/path/`, and should not include the `http://servername`. It doesn't necessarily have to protect a directory (it can be an individual file, or a number of files), and can include wild-cards. In a wild-card string, `?' matches any single character, and `*' matches any sequences of characters.

  Apache 1.2 and above: Extended regular expressions can also be used, with the addition of the `~` character. For example:

         <Location ~ "/(extra|special)/data">

  would match URLs that contained the substring "/extra/data" or "/special/data".

  The `Location` functionality is especially useful when combined with the `SetHandler` directive. For example, to enable status requests, but allow them only from browsers at foo.com, you might use:

          <Location /status>
          SetHandler server-status
          order deny,allow
          deny from all
          allow from .foo.com
          </Location>

  ## LockFile

  Syntax: LockFile filename
  Default: `LockFile logs/accept.lock`
  Context: server config
  Status: core

  The LockFile directive sets the path to the lockfile used when Apache is compiled with either USE_FCNTL_SERIALIZED_ACCEPT or USE_FLOCK_SERIALIZED_ACCEPT. This directive should normally be left at its default value. The main reason for changing it is if the `logs` directory is NFS mounted, since the lockfile should be stored on a local disk if possible. The PID of the main server process is automatically appended to the filename.

  ## MaxClients

  Syntax: MaxClients number
  Default: `MaxClients 256`
  Context: server config
  Status: core

  The MaxClients directive sets the limit on the number of simultaneous requests that can be supported; not more than this number of child server processes will be created.

  ## MaxKeepAliveRequests

  Syntax: MaxKeepAliveRequests number
  Default: `MaxKeepAliveRequests 100`
  Context: server config
  Status: core
  Compatibility: Only available in Apache 1.2 and later.

  The MaxKeepAliveRequests directive limits the number of requests allowed per connection when KeepAlive is on. If it is set to "`0`", unlimited requests will be allowed. We recommend that this setting be kept to a high value for maximum server performance.

  ## MaxRequestsPerChild directive

  Syntax: MaxRequestsPerChild number
  Default: `MaxRequestsPerChild 0`
  Context: server config
  Status: core

  The MaxRequestsPerChild directive sets the limit on the number of requests that an individual child server process will handle. After MaxRequestsPerChild requests, the child process will die. If MaxRequestsPerChild is 0, then the process will never expire.

  Setting MaxRequestsPerChild to a non-zero limit has two beneficial effects:

  - it limits the amount of memory that process can consume by (accidental) memory leakage;
  - by giving processes a finite lifetime, it helps reduce the number of processes when the server load reduces.

  ## MaxSpareServers directive

  Syntax: MaxSpareServers number
  Default: `MaxSpareServers 10`
  Context: server config
  Status: core

  The MaxSpareServers directive sets the desired maximum number of idle child server processes. An idle process is one which is not handling a request. If there are more than MaxSpareServers idle, then the parent process will kill off the excess processes.

  Tuning of this parameter should only be necessary on very busy sites. Setting this parameter to a large number is almost always a bad idea.

  See also MinSpareServers and StartServers.

  ## MinSpareServers directive

  Syntax: MinSpareServers number
  Default: `MinSpareServers 5`
  Context: server config
  Status: core

  The MinSpareServers directive sets the desired minimum number of idle child server processes. An idle process is one which is not handling a request. If there are fewer than MinSpareServers idle, then the parent process creates new children at a maximum rate of 1 per second.

  Tuning of this parameter should only be necessary on very busy sites. Setting this parameter to a large number is almost always a bad idea.

  See also MaxSpareServers and StartServers.

  ## Options directive

  Syntax: Options [+|-]option [+|-]option ...
  Context: server config, virtual host, directory, .htaccess
  Override: Options
  Status: core

  The Options directive controls which server features are available in a particular directory.

  option can be set to `None`, in which case none of the extra features are enabled, or one or more of the following:

  All
    All options except for MultiViews.
  ExecCGI
    Execution of CGI scripts is permitted.
  FollowSymLinks
    The server will follow symbolic links in this directory. Note: even though the server follows the symlink it does not change the pathname used to match against `<Directory>` sections.
  Includes
    Server-side includes are permitted.
  IncludesNOEXEC
    Server-side includes are permitted, but the #exec command and #include of CGI scripts are disabled.
  Indexes
    If a URL which maps to a directory is requested, and the there is no DirectoryIndex (e.g. index.html) in that directory, then the server will return a formatted listing of the directory.
  MultiViews
    Content negotiated MultiViews are allowed.
  SymLinksIfOwnerMatch
    The server will only follow symbolic links for which the target file or directory is owned by the same user id as the link.
  Normally, if multiple `Options` could apply to a directory, then the most specific one is taken complete; the options are not merged. However if all the options on the `Options` directive are preceded by a + or - symbol, the options are merged. Any options preceded by a + are added to the options currently in force, and any options preceded by a - are removed from the options currently in force.

  For example, without any + and - symbols:

  > `<Directory /web/docs>
  > Options Indexes FollowSymLinks
  > </Directory>
  > <Directory /web/docs/spec>
  > Options Includes
  > </Directory>`

  then only `Includes` will be set for the /web/docs/spec directory. However if the second `Options` directive uses the + and - symbols:

  > `<Directory /web/docs>
  > Options Indexes FollowSymLinks
  > </Directory>
  > <Directory /web/docs/spec>
  > Options +Includes -Indexes
  > </Directory>`

  then the options `FollowSymLinks` and `Includes` are set for the /web/docs/spec directory.

  ## PidFile directive

  Syntax: PidFile filename
  Default: `PidFile logs/httpd.pid`
  Context: server config
  Status: core

  The PidFile directive sets the file to which the server records the process id of the daemon. If the filename does not begin with a slash (/) then it is assumed to be relative to the ServerRoot. The PidFile is only used in standalone mode.

  It is often useful to be able to send the server a signal, so that it closes and then reopens its ErrorLog and TransferLog, and re-reads its configuration files. This is done by sending a SIGHUP (kill -1) signal to the process id listed in the PidFile.

  The PidFile is subject to the same warnings about log file placement and security.

  ## Port directive

  Syntax: Port number
  Default: `Port 80`
  Context: server config
  Status: core

  Number is a number from 0 to 65535; some port numbers (especially below 1024) are reserved for particular protocols. See `/etc/services` for a list of some defined ports; the standard port for the http protocol is 80.

  The Port directive has two behaviors, the first of which is necessary for NCSA backwards compatibility (and which is confusing in the context of Apache).

  - In the absence of any Listen or BindAddress directives specifying a port number, the Port directive sets the network port on which the server listens. If there are any Listen or BindAddress directives specifying `:number` then Port has no effect on what address the server listens at.
  - The Port directive sets the `SERVER_PORT` environment variable (for CGI and SSI), and is used when the server must generate a URL that refers to itself (for example when creating an external redirect to itself).
  In no event does a Port setting affect what ports a VirtualHost responds on, the VirtualHost directive itself is used for that.

  The primary behaviour of Port should be considered to be similar to that of the ServerName directive. The ServerName and Port together specify what you consider to be the canonical address of the server.

  Port 80 is one of Unix's special ports. All ports numbered below 1024 are reserved for system use, i.e. regular (non-root) users cannot make use of them; instead they can only use higher port numbers. To use port 80, you must start the server from the root account. After binding to the port and before accepting requests, Apache will change to a low privileged user as set by the User directive.

  If you cannot use port 80, choose any other unused port. Non-root users will have to choose a port number higher than 1023, such as 8000.

  SECURITY: if you do start the server as root, be sure not to set User to root. If you run the server as root whilst handling connections, your site may be open to a major security attack.

  ## require directive

  Syntax: require entity-name entity entity...
  Context: directory, .htaccess
  Override: AuthConfig
  Status: core

  This directive selects which authenticated users can access a directory. The allowed syntaxes are:

  - require user userid userid ...

    Only the named users can access the directory.

  - require group group-name group-name ...

    Only users in the named groups can access the directory.

  - require valid-user

    All valid users can access the directory.

  If `require` appears in a <Limit> section, then it restricts access to the named methods, otherwise it restricts access for all methods. Example:

  > `AuthType Basic
  > AuthName somedomain
  > AuthUserFile /web/users
  > AuthGroupFile /web/groups
  > <Limit GET POST>
  > require group admin
  > </Limit>`

  Require must be accompanied by AuthName and AuthType directives, and directives such as AuthUserFile and AuthGroupFile (to define users and groups) in order to work correctly.

  ## ResourceConfig directive

  Syntax: ResourceConfig filename
  Default: `ResourceConfig conf/srm.conf`
  Context: server config, virtual host
  Status: core

  The server will read this file for more directives after reading the httpd.conf file. Filename is relative to the ServerRoot. This feature can be disabled using:

  > `ResourceConfig /dev/null`

  Historically, this file contained most directives except for server configuration directives and <Directory> sections; in fact it can now contain any server directive allowed in the server config context.

  See also AccessConfig.

  ## RLimitCPU directive

  Syntax: RLimitCPU # or 'max' [# or 'max']
  Default: `Unset uses operating system defaults`
  Context: server config, virtual host
  Status: core
  Compatibility: RLimitCPU is only available in Apache 1.2 and later

  Takes 1 or 2 parameters. The first parameter sets the soft resource limit for all processes and the second parameter sets the maximum resource limit. Either parameter can be a number, or max to indicate to the server that the limit should be set to the maximum allowed by the operating system configuration. Raising the maximum resource limit requires that the server is running as root, or in the initial startup phase.

  CPU resource limits are expressed in seconds per process.

  See also RLimitMEM or RLimitNPROC.

  ## RLimitMEM directive

  Syntax: RLimitMEM # or 'max' [# or 'max']
  Default: `Unset uses operating system defaults`
  Context: server config, virtual host
  Status: core
  Compatibility: RLimitMEM is only available in Apache 1.2 and later

  Takes 1 or 2 parameters. The first parameter sets the soft resource limit for all processes and the second parameter sets the maximum resource limit. Either parameter can be a number, or max to indicate to the server that the limit should be set to the maximum allowed by the operating system configuration. Raising the maximum resource limit requires that the server is running as root, or in the initial startup phase.

  Memory resource limits are expressed in bytes per process.

  See also RLimitCPU or RLimitNPROC.

  ## RLimitNPROC directive

  Syntax: RLimitNPROC # or 'max' [# or 'max']
  Default: `Unset uses operating system defaults`
  Context: server config, virtual host
  Status: core
  Compatibility: RLimitNPROC is only available in Apache 1.2 and later

  Takes 1 or 2 parameters. The first parameter sets the soft resource limit for all processes and the second parameter sets the maximum resource limit. Either parameter can be a number, or max to indicate to the server that the limit should be set to the maximum allowed by the operating system configuration. Raising the maximum resource limit requires that the server is running as root, or in the initial startup phase.

  Process limits control the number of processes per user.

  Note: If CGI processes are not running under userids other than the web server userid, this directive will limit the number of processes that the server itself can create. Evidence of this situation will be indicated by cannot fork messages in the error_log.

  See also RLimitMEM or RLimitCPU.

  ## Satisfy

  Syntax: Satisfy 'any' or 'all'
  Default: Satisfy all
  Context: directory, .htaccess
  Status: core
  Compatibility: Satisfy is only available in Apache 1.2 and later

  Access policy if both allow and require used. The parameter can be either 'all' or 'any'. This directive is only useful if access to a particular area is being restricted by both username/password and client host address. In this case the default behavior ("all") is to require that the client passes the address access restriction and enters a valid username and password. With the "any" option the client will be granted access if they either pass the host restriction or enter a valid username and password. This can be used to password restrict an area, but to let clients from particular addresses in without prompting for a password.

  ## ScoreBoardFile directive

  Syntax: ScoreBoardFile filename
  Default: `ScoreBoardFile logs/apache_status`
  Context: server config
  Status: core

  The ScoreBoardFile directive is required on some architectures to place a file that the server will use to communicate between its children and the parent. The easiest way to find out if your architecture requires a scoreboard file is to run Apache and see if it creates the file named by the directive. If your architecture requires it then you must ensure that this file is not used at the same time by more than one invocation of Apache.

  If you have to use a ScoreBoardFile then you may see improved speed by placing it on a RAM disk. But be careful that you heed the same warnings about log file placement and security.

  Apache 1.2 and above:

  Linux 1.x users might be able to add `-DHAVE_SHMGET` to the `EXTRA_CFLAGS` in your `Configuration`. This might work with some 1.x installations, but won't work with all of them.

  SVR4 users should consider adding `-DHAVE_SHMGET` to the `EXTRA_CFLAGS` in your `Configuration`. This is believed to work, but we were unable to test it in time for 1.2 release.

  See Also: Stopping and Restarting Apache

  ## SendBufferSize directive

  Syntax: SendBufferSize bytes
  Context: server config
  Status: core

  The server will set the TCP buffer size to the number of bytes specified. Very useful to increase past standard OS defaults on high speed high latency (i.e. 100ms or so, such as transcontinental fast pipes)

  ## ServerAdmin directive

  Syntax: ServerAdmin email-address
  Context: server config, virtual host
  Status: core

  The ServerAdmin sets the e-mail address that the server includes in any error messages it returns to the client.

  It may be worth setting up a dedicated address for this, e.g.

  > `ServerAdmin www-admin@foo.bar.com`

  as users do not always mention that they are talking about the server!

  ## ServerAlias directive

  Syntax: ServerAlias host1 host2 ...
  Context: virtual host
  Status: core
  Compatibility: ServerAlias is only available in Apache 1.1 and later.

  The ServerAlias directive sets the alternate names for a host, for use with Host-header based virtual hosts.

  See Also: In-depth description of Virtual Host matching

  ## ServerName directive

  Syntax: ServerName fully-qualified domain name
  Context: server config, virtual host
  Status: core

  The ServerName directive sets the hostname of the server; this is only used when creating redirection URLs. If it is not specified, then the server attempts to deduce it from its own IP address; however this may not work reliably, or may not return the preferred hostname. For example:

  > `ServerName www.wibble.com`

  would be used if the canonical (main) name of the actual machine were `monster.wibble.com`.

  See Also: DNS Issues

  ## ServerPath directive

  Syntax: ServerPath pathname
  Context: virtual host
  Status: core
  Compatibility: ServerPath is only available in Apache 1.1 and later.

  The ServerPath directive sets the legacy URL pathname for a host, for use with Host-header based virtual hosts.

  See Also: In-depth description of Virtual Host matching

  ## ServerRoot directive

  Syntax: ServerRoot directory-filename
  Default: `ServerRoot /usr/local/etc/httpd`
  Context: server config
  Status: core

  The ServerRoot directive sets the directory in which the server lives. Typically it will contain the subdirectories `conf/` and `logs/`. Relative paths for other configuration files are taken as relative to this directory.
  See also the `-d` option to httpd.

  ## ServerType directive

  Syntax: ServerType type
  Default: `ServerType standalone`
  Context: server config
  Status: core

  The ServerType directive sets how the server is executed by the system. Type is one of

  inetd
    The server will be run from the system process inetd; the command to start the server is added to `/etc/inetd.conf`
  standalone
    The server will run as a daemon process; the command to start the server is added to the system startup scripts. (`/etc/rc.local` or `/etc/rc3.d/...`.)
  Inetd is the lesser used of the two options. For each http connection received, a new copy of the server is started from scratch; after the connection is complete, this program exits. There is a high price to pay per connection, but for security reasons, some admins prefer this option.

  Standalone is the most common setting for ServerType since it is far more efficient. The server is started once, and services all subsequent connections. If you intend running Apache to serve a busy site, standalone will probably be your only option.

  SECURITY: if you are paranoid about security, run in inetd mode. Security cannot be guaranteed in either, but whilst most people are happy to use standalone, inetd is probably least prone to attack.

  ## StartServers directive

  Syntax: StartServers number
  Default: `StartServers 5`
  Context: server config
  Status: core

  The StartServers directive sets the number of child server processes created on startup. As the number of processes is dynamically controlled depending on the load, there is usually little reason to adjust this parameter.

  See also MinSpareServers and MaxSpareServers.

  ## TimeOut directive

  Syntax: TimeOut number
  Default: `TimeOut 300`
  Context: server config
  Status: core

  The TimeOut directive currently defines the amount of time Apache will wait for three things:

  1. The total amount of time it takes to receive a GET request.
  2. The amount of time between receipt of TCP packets on a POST or PUT request.
  3. The amount of time between ACKs on transmissions of TCP packets in responses.
  We plan on making these separately configurable at some point down the road. The timer used to default to 1200 before 1.2, but has been lowered to 300 which is still far more than necessary in most situations. It is not set any lower by default because there may still be odd places in the code where the timer is not reset when a packet is sent.

  ## User directive

  Syntax: User unix-userid
  Default: `User #-1`
  Context: server config, virtual host
  Status: core

  The User directive sets the userid as which the server will answer requests. In order to use this directive, the standalone server must be run initially as root. Unix-userid is one of:

  A username
    Refers to the given user by name.
  # followed by a user number.
    Refers to a user by their number.
  The user should have no privileges which result in it being able to access files which are not intended to be visible to the outside world, and similarly, the user should not be able to execute code which is not meant for httpd requests. It is recommended that you set up a new user and group specifically for running the server. Some admins use user `nobody`, but this is not always possible or desirable.

  Notes: If you start the server as a non-root user, it will fail to change to the lesser privileged user, and will instead continue to run as that original user. If you do start the server as root, then it is normal for the parent process to remain running as root.

  Special note: Use of this directive in <VirtualHost> requires a properly configured suEXEC wrapper. When used inside a <VirtualHost> in this manner, only the user that CGIs are run as is affected. Non-CGI requests are still processed with the user specified in the main User directive.

  SECURITY: Don't set User (or Group) to `root` unless you know exactly what you are doing, and what the dangers are.

  ## <VirtualHost> directive

  Syntax: <VirtualHost addr[:port] ...> ... </VirtualHost>
  Context: server config
  Status: Core.
  Compatibility: Non-IP address-based Virtual Hosting only available in Apache 1.1 and later.
  Compatibility: Multiple address support only available in Apache 1.2 and later.

  <VirtualHost> and </VirtualHost> are used to enclose a group of directives which will apply only to a particular virtual host. Any directive which is allowed in a virtual host context may be used. When the server receives a request for a document on a particular virtual host, it uses the configuration directives enclosed in the <VirtualHost> section. Addr can be

- The IP address of the virtual host
- A fully qualified domain name for the IP address of the virtual host. Example:

  > `<VirtualHost 10.1.2.3>
  > ServerAdmin webmaster@host.foo.com
  > DocumentRoot /www/docs/host.foo.com
  > ServerName host.foo.com
  > ErrorLog logs/host.foo.com-error_log
  > TransferLog logs/host.foo.com-access_log
  > </VirtualHost>`

  Each VirtualHost must correspond to a different IP address or a different host name for the server, in the latter case the server machine must be configured to accept IP packets for multiple addresses. (If the machine does not have multiple network interfaces, then this can be accomplished with the `ifconfig alias` command (if your OS supports it), or with kernel patches like VIF (for SunOS(TM) 4.1.x)).

  The special name `_default_` can be specified in which case this virtual host will match any IP address that is not explicitly listed in another virtual host. In the absence of any _default_ virtual host the "main" server config, consisting of all those definitions outside any VirtualHost section, is used when no match occurs.

  You can specify a `:port` to change the port that is matched. If unspecified then it defaults to the same port as the most recent `Port` statement of the main server. You may also specify `:*` to match all ports on that address. (This is recommended when used with `_default_`.)

  SECURITY: See the security tips document for details on why your security could be compromised if the directory where logfiles are stored is writable by anyone other than the user that starts the server.

  See also: Warnings about DNS and Apache
  See also: Information on Virtual Hosts. (multihome)
  See also: Non-IP address-based Virtual Hosts
  See also: In-depth description of Virtual Host matching

  ### Apache HTTP Server Version 1.2